<template>
  <div
    :class="[
      'games-item cursor-pointer group',
      { 'games-item-for-game-page': tabType === 'games' },
    ]"
  >
    <IconFavorite
      :gameData="gameData"
      :checkIsFavourite="checkIsFavourite"
      :redirectToLogin="redirectToLogin"
      :setAndUnsetGameToFavourite="setAndUnsetGameToFavourite"/>
    <div
      class="games-item__img"
      :style="tabType !== 'games' ? 'height:350px' : ''"
    >
      <img
        v-lazy="isImageVersionExist(gameData.GameIconUrl)"
        :alt="gameData.EnglishGameName"
        class="object-contain h-full"
      />
    </div>
    <div
      class="games-item__overlay"
      :style="tabType !== 'games' ? 'height:45%' : ''"
    >
      <div class="games-item__name">
        <p>{{ gameData.GameName }}</p>
      </div>
      <div class="games-item__info">
        <div class="games-item__provider">{{ gameData.GameProviderDisplayName }}</div>
        <div class="flex gap-2">
          <div v-if="gameData.IsNewGame && !gameData.IsHotGame" class="games-item__tags">
            <span class="games-item__tag--top">{{ $t("new") }}</span>
          </div>
          <div v-if="gameData.IsHotGame" class="games-item__tags">
            <span class="games-item__tag--top">{{ $t("Hot") }}</span>
          </div>
        </div>
      </div>
      <div class="games-item__buttons">
        <button
          v-if="gameData.GameId === 74 || gameData.GameProviderName == 'BBin'"
          class="uppercase button button--s2 button--t4 button--play"
          @click="
            gameData.GameId === 74
              ? handleGameEntryOpenWindow(
                  gameData,
                  1200,
                  850,
                  EnumEntranceLocation.GameLobby
                )
              : handleGameEntryOpenWindow(
                  gameData,
                  850,
                  850,
                  EnumEntranceLocation.GameLobby
                )
          "
        >
          {{ $t("play_now") }}
        </button>
        <nuxt-link
          v-else
          :to="
            authenticated
              ? `/Game/${gameData.GameId}?tab=${tabType}&&entrance=${EnumEntranceLocation.GameLobby}`
              : '/login'
          "
          class="uppercase button button--s2 button--t4 button--play"
        >
          {{ $t("play_now") }}
        </nuxt-link>
      </div>
    </div>
  </div>
</template>
<script lang="ts" setup>
import _ from 'lodash';
import { GameBsi } from "@/models/bsiGameList";
import { store } from "@/store";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import { handleGameEntryOpenWindow } from "@/composables/useTheme";
defineProps({
  gameData: {
    type: Object as PropType<GameBsi>,
    required: true,
  },
  tabType: {
    type: String,
    required: true,
  },
  checkIsFavourite: {
    type: Function,
    required: true,
  },
  setAndUnsetGameToFavourite: {
    type: Function,
    required: true,
  },
  redirectToLogin: {
    type: Function,
    required: true,
  }
});
const authenticated = computed(() => store.state.auth);
const isImageVersionExist = (imageURL: string): string => {
  if (_.includes(imageURL, '?v=')) {
    return imageURL;
  }
  return `${imageURL}?v=${store.state.imageVersion}`;
};
</script>
<style scoped>
.games-item {
  max-width: 100%;
  /* max-width: 275px; */
  -webkit-box-sizing: border-box;
  aspect-ratio: auto;
  box-sizing: border-box;
  position: relative;
  -ms-flex-negative: 0;
  flex-shrink: 0;
  margin: 5px;
  border-radius: 8px;
  background-repeat: no-repeat;
  background-position: center;
  background-size: contain;
}
.games-item__img {
  min-width: 142.5px;
  min-height: 142.5px;
  height: 100%;
  overflow: hidden;
  border-radius: 8px;
  -webkit-box-shadow: var(--box-shadow);
  box-shadow: var(--box-shadow);
  display: flex;
  justify-content: center;
  align-items: center;
}
.games-item__img img {
  width: 100%;
}
.games-item__name {
  width: 100%;
}
.games-item__overlay {
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-orient: vertical;
  -webkit-box-direction: normal;
  -ms-flex-direction: column;
  flex-direction: column;
  -webkit-box-pack: end;
  -ms-flex-pack: end;
  justify-content: flex-end;
  -webkit-box-align: center;
  -ms-flex-align: flex-start;
  align-items: flex-start;
  background: var(--button-bg);
  padding: 10px;
  height: 100%;
  position: absolute;
  bottom: -100%;
  left: 0;
  right: 0;
  opacity: 0;
  visibility: hidden;
}
.games-item__name p {
  margin: 0;
  display: block;
  white-space: nowrap;
  width: calc(100% - 20px);
  text-overflow: ellipsis;
  font-weight: bold;
  overflow: hidden;
}

.games-item__buttons {
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-pack: justify;
  -ms-flex-pack: justify;
  justify-content: center;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
  width: 100%;
  height: fit-content;
}
.games-item .games-item__info {
  padding-top: 5px;
  padding-bottom: 5px;
  margin-bottom: auto;
  gap: 5px;
  display: flex;
  flex-direction: column;
}

.games-item__tags {
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  height: auto;
  margin-bottom: 8px;
}
.games-item__tags span {
  padding: 4px 10px;
  min-width: 52px;
  margin-right: 6px;
  text-align: center;
  font-size: 12px;
  line-height: 1.5;
  font-weight: 600;
  color: var(--text2);
  background: var(--button-bg);
  -webkit-box-shadow: var(--box-shadow-inset);
  box-shadow: var(--box-shadow-inset);
  border-radius: 20px;
}
.games-item:hover .games-item__overlay {
  bottom: 0;
  -webkit-box-shadow: var(--box-shadow);
  box-shadow: var(--box-shadow);
  visibility: visible;
  opacity: 1;
  transition: opacity 0.2s ease-out 0s, bottom 0.2s ease-out 0s;
  border-radius: 8px;
}

@media only screen and (min-width: 1300px) {
  .games-item-for-game-page:first-child {
    grid-column: 1/3;
    grid-row: 1/3;
  }
  .games-item-for-game-page:nth-child(6) {
    grid-column: 7/9;
    grid-row: 1/3;
  }

  .games-item-for-game-page:nth-child(19) {
    grid-column: 4/6;
    grid-row: 3/5;
  }

  .games-item-for-game-page:nth-child(24) {
    grid-column: 1/3;
    grid-row: 5/7;
  }

  .games-item-for-game-page:nth-child(36) {
    grid-column: 7/9;
    grid-row: 5/7;
  }

  .games-item-for-game-page:first-child .games-item__overlay,
  .games-item-for-game-page:nth-child(6) .games-item__overlay,
  .games-item-for-game-page:nth-child(19) .games-item__overlay,
  .games-item-for-game-page:nth-child(24) .games-item__overlay,
  .games-item-for-game-page:nth-child(36) .games-item__overlay {
    height: fit-content;
  }

  .games-item-for-game-page:first-child .games-item__name p,
  .games-item-for-game-page:nth-child(6) .games-item__name p,
  .games-item-for-game-page:nth-child(19) .games-item__name p,
  .games-item-for-game-page:nth-child(24) .games-item__name p,
  .games-item-for-game-page:nth-child(36) .games-item__name p {
    font-size: 24px;
  }

  .games-item-for-game-page:first-child .games-item__info,
  .games-item-for-game-page:nth-child(6) .games-item__info,
  .games-item-for-game-page:nth-child(19) .games-item__info,
  .games-item-for-game-page:nth-child(24) .games-item__info,
  .games-item-for-game-page:nth-child(36) .games-item__info {
    -webkit-box-orient: vertical;
    -webkit-box-direction: normal;
    -webkit-box-pack: center;
    -ms-flex-pack: center;
    justify-content: center;
    -webkit-box-align: start;
    -ms-flex-align: start;
    align-items: flex-start;
    font-size: 16px;
    line-height: 24px;
    margin-bottom: 0px;
    flex-direction: row;
    justify-content: space-between;
    align-items: center;
    padding: 10px 0;
    font-size: 16px;
    width: 100%;
  }

  .games-item-for-game-page:first-child .games-item__provider,
  .games-item-for-game-page:nth-child(6) .games-item__provider,
  .games-item-for-game-page:nth-child(19) .games-item__provider,
  .games-item-for-game-page:nth-child(24) .games-item__provider,
  .games-item-for-game-page:nth-child(36) .games-item__provider {
    font-size: 12px;
    line-height: 18px;
    width: 100%;
    margin-bottom: 8px;
  }

  .games-item-for-game-page:first-child .button--play,
  .games-item-for-game-page:nth-child(6) .button--play,
  .games-item-for-game-page:nth-child(19) .button--play,
  .games-item-for-game-page:nth-child(24) .button--play,
  .games-item-for-game-page:nth-child(36) .button--play,
  .games-item-for-game-page:first-child .button--demo,
  .games-item-for-game-page:nth-child(6) .button--demo,
  .games-item-for-game-page:nth-child(19) .button--demo,
  .games-item-for-game-page:nth-child(24) .button--demo,
  .games-item-for-game-page:nth-child(36) .button--demo {
    width: 94px;
    height: 28px;
  }
  .games-item-for-game-page:first-child .button--play,
  .games-item-for-game-page:nth-child(6) .button--play,
  .games-item-for-game-page:nth-child(19) .button--play,
  .games-item-for-game-page:nth-child(24) .button--play,
  .games-item-for-game-page:nth-child(36) .button--play,
  .games-item-for-game-page:first-child .button--demo,
  .games-item-for-game-page:nth-child(6) .button--demo,
  .games-item-for-game-page:nth-child(19) .button--demo,
  .games-item-for-game-page:nth-child(24) .button--demo,
  .games-item-for-game-page:nth-child(36) .button--demo {
    width: 192px;
    height: fit-content;
  }
}
</style>
